// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: solarmodule/solarmodule.proto

package openfmb.solarmodule;

/**
 * <pre>
 * OpenFMB specialization for cap bank discrete control:
 * </pre>
 *
 * Protobuf type {@code solarmodule.SolarDiscreteControlPV}
 */
public final class SolarDiscreteControlPV extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:solarmodule.SolarDiscreteControlPV)
    SolarDiscreteControlPVOrBuilder {
private static final long serialVersionUID = 0L;
  // Use SolarDiscreteControlPV.newBuilder() to construct.
  private SolarDiscreteControlPV(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private SolarDiscreteControlPV() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new SolarDiscreteControlPV();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarDiscreteControlPV_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarDiscreteControlPV_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.solarmodule.SolarDiscreteControlPV.class, openfmb.solarmodule.SolarDiscreteControlPV.Builder.class);
  }

  public static final int LOGICALNODEFORCONTROL_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNodeForControl logicalNodeForControl_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNodeForControl field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNodeForControl() {
    return logicalNodeForControl_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNodeForControl.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForControl getLogicalNodeForControl() {
    return logicalNodeForControl_ == null ? openfmb.commonmodule.LogicalNodeForControl.getDefaultInstance() : logicalNodeForControl_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeForControlOrBuilder getLogicalNodeForControlOrBuilder() {
    return logicalNodeForControl_ == null ? openfmb.commonmodule.LogicalNodeForControl.getDefaultInstance() : logicalNodeForControl_;
  }

  public static final int CONTROL_FIELD_NUMBER = 2;
  private openfmb.solarmodule.SolarPoint control_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPoint control = 2;</code>
   * @return Whether the control field is set.
   */
  @java.lang.Override
  public boolean hasControl() {
    return control_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPoint control = 2;</code>
   * @return The control.
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarPoint getControl() {
    return control_ == null ? openfmb.solarmodule.SolarPoint.getDefaultInstance() : control_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.solarmodule.SolarPoint control = 2;</code>
   */
  @java.lang.Override
  public openfmb.solarmodule.SolarPointOrBuilder getControlOrBuilder() {
    return control_ == null ? openfmb.solarmodule.SolarPoint.getDefaultInstance() : control_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNodeForControl_ != null) {
      output.writeMessage(1, getLogicalNodeForControl());
    }
    if (control_ != null) {
      output.writeMessage(2, getControl());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNodeForControl_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNodeForControl());
    }
    if (control_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getControl());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.solarmodule.SolarDiscreteControlPV)) {
      return super.equals(obj);
    }
    openfmb.solarmodule.SolarDiscreteControlPV other = (openfmb.solarmodule.SolarDiscreteControlPV) obj;

    if (hasLogicalNodeForControl() != other.hasLogicalNodeForControl()) return false;
    if (hasLogicalNodeForControl()) {
      if (!getLogicalNodeForControl()
          .equals(other.getLogicalNodeForControl())) return false;
    }
    if (hasControl() != other.hasControl()) return false;
    if (hasControl()) {
      if (!getControl()
          .equals(other.getControl())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNodeForControl()) {
      hash = (37 * hash) + LOGICALNODEFORCONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNodeForControl().hashCode();
    }
    if (hasControl()) {
      hash = (37 * hash) + CONTROL_FIELD_NUMBER;
      hash = (53 * hash) + getControl().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.solarmodule.SolarDiscreteControlPV parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.solarmodule.SolarDiscreteControlPV prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * OpenFMB specialization for cap bank discrete control:
   * </pre>
   *
   * Protobuf type {@code solarmodule.SolarDiscreteControlPV}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:solarmodule.SolarDiscreteControlPV)
      openfmb.solarmodule.SolarDiscreteControlPVOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarDiscreteControlPV_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarDiscreteControlPV_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.solarmodule.SolarDiscreteControlPV.class, openfmb.solarmodule.SolarDiscreteControlPV.Builder.class);
    }

    // Construct using openfmb.solarmodule.SolarDiscreteControlPV.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNodeForControl_ = null;
      if (logicalNodeForControlBuilder_ != null) {
        logicalNodeForControlBuilder_.dispose();
        logicalNodeForControlBuilder_ = null;
      }
      control_ = null;
      if (controlBuilder_ != null) {
        controlBuilder_.dispose();
        controlBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.solarmodule.Solarmodule.internal_static_solarmodule_SolarDiscreteControlPV_descriptor;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarDiscreteControlPV getDefaultInstanceForType() {
      return openfmb.solarmodule.SolarDiscreteControlPV.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarDiscreteControlPV build() {
      openfmb.solarmodule.SolarDiscreteControlPV result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.solarmodule.SolarDiscreteControlPV buildPartial() {
      openfmb.solarmodule.SolarDiscreteControlPV result = new openfmb.solarmodule.SolarDiscreteControlPV(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.solarmodule.SolarDiscreteControlPV result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNodeForControl_ = logicalNodeForControlBuilder_ == null
            ? logicalNodeForControl_
            : logicalNodeForControlBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.control_ = controlBuilder_ == null
            ? control_
            : controlBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.solarmodule.SolarDiscreteControlPV) {
        return mergeFrom((openfmb.solarmodule.SolarDiscreteControlPV)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.solarmodule.SolarDiscreteControlPV other) {
      if (other == openfmb.solarmodule.SolarDiscreteControlPV.getDefaultInstance()) return this;
      if (other.hasLogicalNodeForControl()) {
        mergeLogicalNodeForControl(other.getLogicalNodeForControl());
      }
      if (other.hasControl()) {
        mergeControl(other.getControl());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeForControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getControlFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNodeForControl logicalNodeForControl_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForControl, openfmb.commonmodule.LogicalNodeForControl.Builder, openfmb.commonmodule.LogicalNodeForControlOrBuilder> logicalNodeForControlBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNodeForControl field is set.
     */
    public boolean hasLogicalNodeForControl() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNodeForControl.
     */
    public openfmb.commonmodule.LogicalNodeForControl getLogicalNodeForControl() {
      if (logicalNodeForControlBuilder_ == null) {
        return logicalNodeForControl_ == null ? openfmb.commonmodule.LogicalNodeForControl.getDefaultInstance() : logicalNodeForControl_;
      } else {
        return logicalNodeForControlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForControl(openfmb.commonmodule.LogicalNodeForControl value) {
      if (logicalNodeForControlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNodeForControl_ = value;
      } else {
        logicalNodeForControlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNodeForControl(
        openfmb.commonmodule.LogicalNodeForControl.Builder builderForValue) {
      if (logicalNodeForControlBuilder_ == null) {
        logicalNodeForControl_ = builderForValue.build();
      } else {
        logicalNodeForControlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNodeForControl(openfmb.commonmodule.LogicalNodeForControl value) {
      if (logicalNodeForControlBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNodeForControl_ != null &&
          logicalNodeForControl_ != openfmb.commonmodule.LogicalNodeForControl.getDefaultInstance()) {
          getLogicalNodeForControlBuilder().mergeFrom(value);
        } else {
          logicalNodeForControl_ = value;
        }
      } else {
        logicalNodeForControlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNodeForControl() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNodeForControl_ = null;
      if (logicalNodeForControlBuilder_ != null) {
        logicalNodeForControlBuilder_.dispose();
        logicalNodeForControlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForControl.Builder getLogicalNodeForControlBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeForControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeForControlOrBuilder getLogicalNodeForControlOrBuilder() {
      if (logicalNodeForControlBuilder_ != null) {
        return logicalNodeForControlBuilder_.getMessageOrBuilder();
      } else {
        return logicalNodeForControl_ == null ?
            openfmb.commonmodule.LogicalNodeForControl.getDefaultInstance() : logicalNodeForControl_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNodeForControl logicalNodeForControl = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNodeForControl, openfmb.commonmodule.LogicalNodeForControl.Builder, openfmb.commonmodule.LogicalNodeForControlOrBuilder> 
        getLogicalNodeForControlFieldBuilder() {
      if (logicalNodeForControlBuilder_ == null) {
        logicalNodeForControlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNodeForControl, openfmb.commonmodule.LogicalNodeForControl.Builder, openfmb.commonmodule.LogicalNodeForControlOrBuilder>(
                getLogicalNodeForControl(),
                getParentForChildren(),
                isClean());
        logicalNodeForControl_ = null;
      }
      return logicalNodeForControlBuilder_;
    }

    private openfmb.solarmodule.SolarPoint control_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarPoint, openfmb.solarmodule.SolarPoint.Builder, openfmb.solarmodule.SolarPointOrBuilder> controlBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     * @return Whether the control field is set.
     */
    public boolean hasControl() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     * @return The control.
     */
    public openfmb.solarmodule.SolarPoint getControl() {
      if (controlBuilder_ == null) {
        return control_ == null ? openfmb.solarmodule.SolarPoint.getDefaultInstance() : control_;
      } else {
        return controlBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public Builder setControl(openfmb.solarmodule.SolarPoint value) {
      if (controlBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        control_ = value;
      } else {
        controlBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public Builder setControl(
        openfmb.solarmodule.SolarPoint.Builder builderForValue) {
      if (controlBuilder_ == null) {
        control_ = builderForValue.build();
      } else {
        controlBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public Builder mergeControl(openfmb.solarmodule.SolarPoint value) {
      if (controlBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          control_ != null &&
          control_ != openfmb.solarmodule.SolarPoint.getDefaultInstance()) {
          getControlBuilder().mergeFrom(value);
        } else {
          control_ = value;
        }
      } else {
        controlBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public Builder clearControl() {
      bitField0_ = (bitField0_ & ~0x00000002);
      control_ = null;
      if (controlBuilder_ != null) {
        controlBuilder_.dispose();
        controlBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public openfmb.solarmodule.SolarPoint.Builder getControlBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getControlFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    public openfmb.solarmodule.SolarPointOrBuilder getControlOrBuilder() {
      if (controlBuilder_ != null) {
        return controlBuilder_.getMessageOrBuilder();
      } else {
        return control_ == null ?
            openfmb.solarmodule.SolarPoint.getDefaultInstance() : control_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.solarmodule.SolarPoint control = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.solarmodule.SolarPoint, openfmb.solarmodule.SolarPoint.Builder, openfmb.solarmodule.SolarPointOrBuilder> 
        getControlFieldBuilder() {
      if (controlBuilder_ == null) {
        controlBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.solarmodule.SolarPoint, openfmb.solarmodule.SolarPoint.Builder, openfmb.solarmodule.SolarPointOrBuilder>(
                getControl(),
                getParentForChildren(),
                isClean());
        control_ = null;
      }
      return controlBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:solarmodule.SolarDiscreteControlPV)
  }

  // @@protoc_insertion_point(class_scope:solarmodule.SolarDiscreteControlPV)
  private static final openfmb.solarmodule.SolarDiscreteControlPV DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.solarmodule.SolarDiscreteControlPV();
  }

  public static openfmb.solarmodule.SolarDiscreteControlPV getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<SolarDiscreteControlPV>
      PARSER = new com.google.protobuf.AbstractParser<SolarDiscreteControlPV>() {
    @java.lang.Override
    public SolarDiscreteControlPV parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<SolarDiscreteControlPV> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<SolarDiscreteControlPV> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.solarmodule.SolarDiscreteControlPV getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

